package control;

import java.util.ArrayList;
import java.util.HashMap;
import java.util.List;
import java.util.Map;

import entity.Pizza;
import entity.PizzaInterface;
import entity.Zutat;
import main.Eingabe;

public class Pizzeria {
	private List<PizzaInterface> pizze;
	private Map<String,Zutat> zutaten;
	 
	public Pizzeria() {
		this.pizze = new ArrayList<>();
		this.zutaten = new HashMap<>();
		List<Zutat> tmp = new ArrayList<>();
		tmp.addAll(List.of(
				new Zutat("Champignon", 0, 150)
				, new Zutat("Prosciutto", 60, 200)
				, new Zutat("Spinat", 40, 150)
				, new Zutat("Ei", 0, 180)
				, new Zutat("Knoblauch", 0, 120)
				, new Zutat("gegrilltes Gemuese", 0, 170)
				, new Zutat("Ruccola", 0, 30)
				, new Zutat("extra Kaese", 90, 200)
				, new Zutat("Basilikum", 0, 50)
				));
		for(Zutat z: tmp) {
			this.zutaten.put(z.getName(), z);
		}
		this.pizze.add(new Pizza("Margherita"));
		this.pizze.add(new Pizza("Funghi")
				.zutatHinzu(this.zutaten.get("Champignon").clone()));
		this.pizze.add(new Pizza("Prosciutto e Funghi")
				.zutatHinzu(this.zutaten.get("Champignon").clone())
				.zutatHinzu(this.zutaten.get("Prosciutto").clone()));
		this.pizze.add(new Pizza("Braccio Di Ferro")
				.zutatHinzu(this.zutaten.get("Spinat").clone())
				.zutatHinzu(this.zutaten.get("Ei").clone())
				.zutatHinzu(this.zutaten.get("Knoblauch").clone())
				);
		this.pizze.add(new Pizza("Vegetariana")
				.zutatHinzu(this.zutaten.get("Champignon").clone())
				.zutatHinzu(this.zutaten.get("gegrilltes Gemuese").clone())
				.zutatHinzu(this.zutaten.get("Ruccola").clone())
				.zutatHinzu(this.zutaten.get("Knoblauch").clone())
				);
	}
	
	public PizzaInterface pizzaAuswaehlen() {
		if (this.pizze.size() < 1) {
			return null;
		}
		 int count = 1;
		 for(PizzaInterface p: this.pizze) {
			 System.out.println(" (" + (count++) + ") " + p.getTyp());
		 }
		 System.out.println(" (0) Programm beenden"); 
		 System.out.print("Welche Pizza: "); 
		 int ein = -1; 
		 while (ein < 0 || ein > this.pizze.size()) {
			 ein = Eingabe.leseInt();
		 }
		 if (ein == 0) {
			 return null;
		 }
		 return this.pizze.get(ein-1).clone();
	}
	
	public Zutat zutatAuswaehlen() {
		List<Zutat> tmp = new ArrayList<>();
		tmp.addAll(this.zutaten.values());
		if (tmp.size() < 1) {
			return null;
		}
		 int count = 1;
		 for(Zutat z: tmp) {
			 System.out.println(" (" + (count++) + ") " + z.getName() + " " + z.getPreis());
		 }
		 System.out.println(" (0) Hinzufuegen beenden"); 
		 System.out.print("Welche Zutat: "); 
		 int ein = -1; 
		 while (ein < 0 || ein > tmp.size()) {
			 ein = Eingabe.leseInt();
		 }
		 if (ein == 0) {
			 return null;
		 }
		 return this.zutaten.get(tmp.get(ein-1).getName()).clone(); 
	}
	
	public Zutat zutatLoeschen(PizzaInterface p) {
		List<Zutat> tmp = p.getZutaten();
		if (tmp.size() < 1) {
			return null;
		}
		 int count = 1;
		 for(Zutat z: tmp) {
			 System.out.println(" (" + (count++) + ") " + z.getName() + " " + z.getPreis());
		 }
		 System.out.println(" (0) Entfernen beenden"); 
		 System.out.print("Welche Zutat loeschen: "); 
		 int ein = -1; 
		 while (ein < 0 || ein > tmp.size()) {
			 ein = Eingabe.leseInt();
		 }
		 if (ein == 0) {
			 return null;
		 }
		 return tmp.get(ein - 1); 
	}
}
