package entity;

import java.util.ArrayList;
import java.util.List;

public class Pizza implements Cloneable, PizzaInterface{
	private String typ;
	private int basiszeit = 380;
	private int basispreis = 600;
	private List<Zutat> zutaten;
	
	public Pizza(String name) {
		this.typ = name;
		this.zutaten = new ArrayList<>();
	}
	
	@Override
	public Pizza zutatHinzu(Zutat z) {
		this.zutaten.add(z);
		return this;
	}
	
	@Override
	public PizzaInterface zutatWeg(String name) {
		Zutat weg = null;
		for(Zutat z: this.zutaten) {
			if(name.equals(z.getName())) {
				weg = z;
			}
		}
		if(weg != null) {
			this.zutaten.remove(weg);
		}
		return this;
	}
	
	@Override
	public int backzeit() {
		int erg = this.basiszeit;
		for(Zutat z: this.zutaten) {
			erg += z.getBackzeit();
		}
		return erg;
	}
	
	@Override
	public int preis() {
		int erg = this.basispreis;
		for(Zutat z: this.zutaten) {
			erg += z.getPreis();
		}
		return erg;
	}
	
	@Override
	public String rechnung() {
		List<String> text = new ArrayList<>();
		for(Zutat z: this.zutaten) {
			z.aufRechnung(text);
		}
		text.sort(null);
		StringBuilder sb = new StringBuilder("Pizza " 
				+ "\t" + this.basispreis + "\n");
		for(String p: text) {
			sb.append(p + "\n");
		}
		return sb.toString();
	}
	
	@Override
	public Pizza clone() {
		Pizza erg = new Pizza(this.typ);
		erg.basispreis = this.basispreis;
		erg.basiszeit = this.basiszeit;
		for(Zutat z: this.zutaten) {
			erg.zutatHinzu(z);
		}
		return erg;
	}

	@Override
	public String getTyp() {
		return typ;
	}

	public void setTyp(String name) {
		this.typ = name;
	}

	public int getBasiszeit() {
		return basiszeit;
	}

	public void setBasiszeit(int basiszeit) {
		this.basiszeit = basiszeit;
	}

	public int getBasispreis() {
		return basispreis;
	}

	public void setBasispreis(int basispreis) {
		this.basispreis = basispreis;
	}

	@Override
	public List<Zutat> getZutaten() {
		return zutaten;
	}

	public void setZutaten(List<Zutat> zutaten) {
		this.zutaten = zutaten;
	}
	
}
